#define LINUX 1
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#ifdef LINUX
#include <sys/stat.h>
#include <sys/mman.h>
#include <sys/wait.h>
#include <sys/ioctl.h>
#include <hijack.h>
#include <empeg.h>
#include <unistd.h>
#endif


struct menuItem {	
	char	*title;
	char	*command;
};

extern char **environ;

int main(int argc, char *argv[])
{	
	FILE *cfgfp;	
	struct menuItem *menuItems[25];
	int num_items,i,fd,item_sel,status,debug_index;
	pid_t apid;
	char s[256],*title,*command,*bashargs[4];
	/*unsigned long data, waitb[] = {7,
        IR_RIGHT_BUTTON_RELEASED,
		IR_RIGHT_BUTTON_PRESSED,
		IR_LEFT_BUTTON_RELEASED,
		IR_LEFT_BUTTON_RELEASED,
		IR_BOTTOM_BUTTON_RELEASED,
		IR_BOTTOM_BUTTON_PRESSED,
		IR_TOP_BUTTON_PRESSED};*/
	char *hijack_menus[25];

	if ( argc < 2 ) {
		fprintf(stderr,
			"usage: %s <configfile>\n",argv[0]);
		exit(1);
	}

    // used for debugging...pass a number which hijack
	// would select to test a menu item out
	debug_index = -1;
	if(argc==3) {
		debug_index = atoi(argv[2]);
	}

	cfgfp = fopen(argv[1], "r");
	if ( cfgfp == NULL ) 
		return 1;

	num_items = -1;
	while (fgets(s, sizeof(s),cfgfp) != NULL ) {
		num_items++;
		title = (char *)strdup(strtok(s,":"));
		command = (char *)strdup(strtok(NULL,"\n"));		
		menuItems[num_items] = (struct menuItem *)malloc(sizeof(struct menuItem));		
		menuItems[num_items]->title = title;
		menuItems[num_items]->command = command;		
		
	}	
	fclose(cfgfp);	
	
    for(i=0;i<=num_items;i++) {
		hijack_menus[i] = (char*)malloc(strlen(menuItems[i]->title));
		strcpy(hijack_menus[i],menuItems[i]->title);
	}
	hijack_menus[i] = NULL;	


    fd = open("/dev/display",O_RDWR);        
    while(1) {
		// here is where we wait on a menu item to be selected
		if(debug_index!= -1) {
			item_sel = debug_index;
			debug_index = -1;
		}
		else
			item_sel = ioctl(fd,EMPEG_HIJACK_WAITMENU,hijack_menus);

		if((item_sel >= 0) && (item_sel<=num_items)) {
			apid = fork();
			if(apid==-1) {
			  // could not open thread :p
			  ioctl(fd,EMPEG_HIJACK_DISPTEXT,"error forking");	
			}
			// child process goes here
			if(apid==0) {
				// execute the given command
				bashargs[0] = "sh";
				bashargs[1] =  "-c";
				bashargs[2] = menuItems[item_sel]->command;
				bashargs[3] = NULL;				
				execve("/bin/sh",bashargs,environ);			
				wait(&status);
			}
			//system(menuItems[item_sel]->command);
		}
	}
	return 0;
}
